Index: /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2408)
@@ -41,4 +41,5 @@
 
 
+! Local variables
   CHARACTER (LEN=20) :: modname = 'cv3_param'
   CHARACTER (LEN=80) :: abort_message
@@ -384,5 +385,5 @@
     IF (ok_new_feed) THEN
       IF (iter==niter) THEN
-        DO k = minorig, nd
+        DO k = minorig, nl
           DO i = 1, len
             IF (ph(i,k)>=plclfeed(i)) pfeedmin(i) = ph(i, k)
@@ -891,8 +892,8 @@
                         h, lv, cpn, p, ph, tv, tp, tvp, clw, &
                         sig, w0)
+  USE print_control_mod, ONLY: lunout
   IMPLICIT NONE
 
   include "cv3param.h"
-  include 'iniprint.h'
 
 !inputs:
@@ -971,5 +972,5 @@
     WRITE (lunout, *) 'strange! nn not equal to ncum: ', nn, ncum
     abort_message = ''
-    CALL abort_gcm(modname, abort_message, 1)
+    CALL abort_physic(modname, abort_message, 1)
   END IF
 
@@ -1074,4 +1075,5 @@
   REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ep, sigp, hp
   REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: buoy
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: frac
 
 !local variables:
@@ -1082,5 +1084,4 @@
   REAL by, defrac, pden, tbis
   REAL ah0(nloc), cape(nloc), capem(nloc), byp(nloc)
-  REAL frac(nloc, nd)
   LOGICAL lcape(nloc)
   INTEGER iposit(nloc)
@@ -1515,5 +1516,5 @@
 ! =====================================================================
 
-  DO k = 1, nd
+  DO k = 1, nl
     DO i = 1, ncum
       hp(i, k) = h(i, k)
@@ -1532,4 +1533,12 @@
           hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k)+frac(i,k)*lf(i,k))* &
                               ep(i, k)*clw(i, k)
+        END IF
+      END DO
+    END DO
+! Below cloud base, set ice fraction to cloud base value
+    DO k = 1, nl
+      DO i = 1, ncum
+        IF (k<icb(i)) THEN
+          frac(i,k) = frac(i,icb(i))
         END IF
       END DO
@@ -2181,6 +2190,6 @@
 ! MAF: renormalisation de MENT
   CALL zilch(zm, nloc*na)
-  DO jm = 1, nd
-    DO im = 1, nd
+  DO jm = 1, nl
+    DO im = 1, nl
       DO il = 1, ncum
         zm(il, im) = zm(il, im) + (1.-sij(il,im,jm))*ment(il, im, jm)
@@ -2189,6 +2198,6 @@
   END DO
 
-  DO jm = 1, nd
-    DO im = 1, nd
+  DO jm = 1, nl
+    DO im = 1, nl
       DO il = 1, ncum
         IF (zm(il,im)/=0.) THEN
@@ -2199,6 +2208,6 @@
   END DO
 
-  DO jm = 1, nd
-    DO im = 1, nd
+  DO jm = 1, nl
+    DO im = 1, nl
       DO il = 1, ncum
         qents(il, im, jm) = qent(il, im, jm)
@@ -2218,4 +2227,5 @@
                      faci, b, sigd, &
                      wdtrainA, wdtrainM)                                      ! RomP
+  USE print_control_mod, ONLY: prt_level, lunout
   IMPLICIT NONE
 
@@ -2227,31 +2237,35 @@
 
 !inputs:
-  INTEGER ncum, nd, na, ntra, nloc
-  INTEGER icb(nloc), inb(nloc)
-  REAL delt, plcl(nloc)
-  REAL t(nloc, nd), rr(nloc, nd), rs(nloc, nd), gz(nloc, na)
-  REAL u(nloc, nd), v(nloc, nd)
+  INTEGER, INTENT (IN)                               :: ncum, nd, na, ntra, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb
+  REAL, INTENT(IN)                                   :: delt
+  REAL, DIMENSION (nloc), INTENT (IN)                :: plcl
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, rr, rs
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: gz
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: u, v
   REAL tra(nloc, nd, ntra)
   REAL p(nloc, nd), ph(nloc, nd+1)
-  REAL ep(nloc, na), sigp(nloc, na), clw(nloc, na)
-  REAL th(nloc, na), tv(nloc, na), lv(nloc, na), cpn(nloc, na)
-  REAL lf(nloc, na)
-  REAL m(nloc, na), ment(nloc, na, na), elij(nloc, na, na)
-  REAL coef_clos(nloc)
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: ep, sigp, clw
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: th, tv, lv, cpn
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: lf
+  REAL, DIMENSION (nloc, na), INTENT (IN)            :: m
+  REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: ment, elij
+  REAL, DIMENSION (nloc), INTENT (IN)                :: coef_clos
 
 !input/output
-  INTEGER iflag(nloc)
+  INTEGER, DIMENSION (nloc), INTENT (INOUT)          :: iflag(nloc)
 
 !outputs:
-  REAL mp(nloc, na), rp(nloc, na), up(nloc, na), vp(nloc, na)
-  REAL water(nloc, na), evap(nloc, na), wt(nloc, na)
-  REAL ice(nloc, na), fondue(nloc, na), faci(nloc, na)
-  REAL trap(nloc, na, ntra)
-  REAL b(nloc, na), sigd(nloc)
+  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: mp, rp, up, vp
+  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: water, evap, wt
+  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: ice, fondue, faci
+  REAL, DIMENSION (nloc, na, ntra), INTENT (OUT)     :: trap
+  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: b
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: sigd
 ! 25/08/10 - RomP---- ajout des masses precipitantes ejectees
 ! de l ascendance adiabatique et des flux melanges Pa et Pm.
 ! Distinction des wdtrain
 ! Pa = wdtrainA     Pm = wdtrainM
-  REAL wdtrainA(nloc, na), wdtrainM(nloc, na)
+  REAL, DIMENSION (nloc, na), INTENT (OUT)           :: wdtrainA, wdtrainM
 
 !local variables
@@ -2273,10 +2287,10 @@
 ! ------------------------------------------------------
 
-  delti = 1./delt
-  tinv = 1./3.
-
-  mp(:, :) = 0.
-
-  DO i = 1, nl
+! =============================
+! --- INITIALIZE OUTPUT ARRAYS 
+! =============================
+!  (loops up to nl+1)
+
+  DO i = 1, nlp
     DO il = 1, ncum
       mp(il, i) = 0.0
@@ -2286,16 +2300,43 @@
       wt(il, i) = 0.001
       water(il, i) = 0.0
-      frac(il, i) = 0.0
       faci(il, i) = 0.0
-      fraci(il, i) = 0.0
       ice(il, i) = 0.0
-      prec(il, i) = 0.0
       fondue(il, i) = 0.0
       evap(il, i) = 0.0
       b(il, i) = 0.0
+    END DO
+  END DO
+!! RomP >>>
+  DO i = 1, nlp
+    DO il = 1, ncum
+      wdtrainA(il, i) = 0.0
+      wdtrainM(il, i) = 0.0
+    END DO
+  END DO
+!! RomP <<<
+
+! ***  Set the fractionnal area sigd of precipitating downdraughts
+  DO il = 1, ncum
+    sigd(il) = sigdz*coef_clos(il)
+  END DO
+
+! =====================================================================
+! --- INITIALIZE VARIOUS ARRAYS AND PARAMETERS USED IN THE COMPUTATIONS
+! =====================================================================
+!  (loops up to nl+1)
+
+  delti = 1./delt
+  tinv = 1./3.
+
+  DO i = 1, nlp
+    DO il = 1, ncum
+      frac(il, i) = 0.0
+      fraci(il, i) = 0.0
+      prec(il, i) = 0.0
       lvcp(il, i) = lv(il, i)/cpn(il, i)
       lfcp(il, i) = lf(il, i)/cpn(il, i)
     END DO
   END DO
+
 !AC!        do k=1,ntra
 !AC!         do i=1,nd
@@ -2305,12 +2346,4 @@
 !AC!         enddo
 !AC!        enddo
-!! RomP >>>
-  DO i = 1, nd
-    DO il = 1, ncum
-      wdtrainA(il, i) = 0.0
-      wdtrainM(il, i) = 0.0
-    END DO
-  END DO
-!! RomP <<<
 
 ! ***  check whether ep(inb)=0, if so, skip precipitating    ***
@@ -2322,9 +2355,4 @@
 !!          if(ep(il,inb(il)).lt.0.0001)lwork(il)=.FALSE.
     lwork(il) = ep(il, inb(il)) >= 0.0001
-  END DO
-
-! ***  Set the fractionnal area sigd of precipitating downdraughts
-  DO il = 1, ncum
-    sigd(il) = sigdz*coef_clos(il)
   END DO
 
@@ -2440,4 +2468,10 @@
         bfac = 1./(sigd(il)*wt(il,i))
 
+!
+    IF (prt_level >= 20) THEN
+      Print*, 'cv3_unsat after provisional rp estimate: rp, afac, bfac ', &
+          i, rp(1, i), afac,bfac
+    ENDIF
+!
 !JYG1
 ! cc        sigt=1.0
@@ -2514,4 +2548,10 @@
           evap(il, i) = (wdtrain(il)+sigd(il)*wt(il,i)*(prec(il,i+1)-prec(il,i))) / &
                         (sigd(il)*(ph(il,i)-ph(il,i+1))*100.)
+!
+    IF (prt_level >= 20) THEN
+      Print*, 'cv3_unsat after evap computation: wdtrain, sigd, wt, prec(i+1),prec(i) ', &
+          i, wdtrain(1), sigd(1), wt(1,i), prec(1,i+1),prec(1,i)
+    ENDIF
+!
 
           d6 = bfac*wdtrain(il) - 100.*sigd(il)*bfac*(ph(il,i)-ph(il,i+1))*evap(il, i)
@@ -2713,4 +2753,10 @@
     END DO
 ! ----------------------------------------------------------------
+!
+    IF (prt_level >= 20) THEN
+      Print*, 'cv3_unsat after mp computation: mp, b(i), b(i-1) ', &
+          i, mp(1, i), b(1,i), b(1,max(i-1,1))
+    ENDIF
+!
 
 ! ***       find mixing ratio of precipitating downdraft     ***
@@ -2804,5 +2850,6 @@
                      nent, elij, traent, sig, &
                      tv, tvp, wghti, &
-                     iflag, precip, Vprecip, ft, fr, fu, fv, ftra, &
+                     iflag, precip, Vprecip, Vprecipi, &     ! jyg: Vprecipi
+                     ft, fr, fu, fv, ftra, &                 ! jyg
                      cbmf, upwd, dnwd, dnwd0, ma, mip, &
 !!                     tls, tps,                             ! useless . jyg
@@ -2818,46 +2865,54 @@
 
 !inputs:
-      INTEGER iflag_mix
-      INTEGER ncum, nd, na, ntra, nloc
-      LOGICAL ok_conserv_q
-      INTEGER icb(nloc), inb(nloc)
-      REAL delt
-      REAL t(nloc, nd), rr(nloc, nd), u(nloc, nd), v(nloc, nd)
-      REAL t_wake(nloc, nd), rr_wake(nloc, nd)
-      REAL s_wake(nloc)
-      REAL tra(nloc, nd, ntra), sig(nloc, nd)
-      REAL gz(nloc, na), ph(nloc, nd+1), h(nloc, na), hp(nloc, na)
-      REAL th(nloc, na), p(nloc, nd), tp(nloc, na)
-      REAL lv(nloc, na), cpn(nloc, na), ep(nloc, na), clw(nloc, na)
-      REAL lf(nloc, na)
-      REAL m(nloc, na), mp(nloc, na), rp(nloc, na), up(nloc, na)
-      REAL vp(nloc, na), wt(nloc, nd), trap(nloc, nd, ntra)
-      REAL water(nloc, na), evap(nloc, na), b(nloc, na), sigd(nloc)
-      REAL fondue(nloc, na), faci(nloc, na), ice(nloc, na)
-      REAL ment(nloc, na, na), qent(nloc, na, na), uent(nloc, na, na)
-      REAL hent(nloc, na, na)
-!IM bug   real vent(nloc,na,na), nent(nloc,na), elij(nloc,na,na)
-      REAL vent(nloc, na, na), elij(nloc, na, na)
-      INTEGER nent(nloc, nd)
-      REAL traent(nloc, na, na, ntra)
-      REAL tv(nloc, nd), tvp(nloc, nd), wghti(nloc, nd)
+      INTEGER, INTENT (IN)                               :: iflag_mix
+      INTEGER, INTENT (IN)                               :: ncum, nd, na, ntra, nloc
+      LOGICAL, INTENT (IN)                               :: ok_conserv_q
+      INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb
+      REAL, INTENT (IN)                                  :: delt
+      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t, rr, u, v
+      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: t_wake, rr_wake
+      REAL, DIMENSION (nloc), INTENT (IN)                :: s_wake
+      REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: tra
+      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
+      REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: gz, h, hp
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: th, tp
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: lv, cpn, ep, clw
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: lf
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: rp, up
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: vp
+      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: wt
+      REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: trap
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: water, evap, b
+      REAL, DIMENSION (nloc, na), INTENT (IN)            :: fondue, faci, ice
+      REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: qent, uent
+      REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: hent
+      REAL, DIMENSION (nloc, na, na), INTENT (IN)        :: vent, elij
+      INTEGER, DIMENSION (nloc, nd), INTENT (IN)         :: nent
+      REAL, DIMENSION (nloc, na, na, ntra), INTENT (IN)  :: traent
+      REAL, DIMENSION (nloc, nd), INTENT (IN)            :: tv, tvp, wghti
+      REAL,INTENT(IN)                                    :: tau_cld_cv, coefw_cld_cv
 !
 !input/output:
-      INTEGER iflag(nloc)
-      REAL,INTENT(in) :: tau_cld_cv, coefw_cld_cv
+      REAL, DIMENSION (nloc, na), INTENT (INOUT)         :: m, mp
+      REAL, DIMENSION (nloc, na, na), INTENT (INOUT)     :: ment
+      INTEGER, DIMENSION (nloc), INTENT (INOUT)          :: iflag
+      REAL, DIMENSION (nloc, nd), INTENT (INOUT)         :: sig
+      REAL, DIMENSION (nloc), INTENT (INOUT)             :: sigd
 !
 !outputs:
-      REAL precip(nloc)
-      REAL ft(nloc, nd), fr(nloc, nd), fu(nloc, nd), fv(nloc, nd)
-      REAL ftd(nloc, nd), fqd(nloc, nd)
-      REAL ftra(nloc, nd, ntra)
-      REAL upwd(nloc, nd), dnwd(nloc, nd), ma(nloc, nd)
-      REAL dnwd0(nloc, nd), mip(nloc, nd)
-      REAL Vprecip(nloc, nd+1)
-!!      REAL tls(nloc, nd), tps(nloc, nd)                 ! useless . jyg
-      REAL qcondc(nloc, nd) ! cld
-      REAL qtc(nloc,nd), sigt(nloc,nd) ! cld
-      REAL wd(nloc) ! gust
-      REAL cbmf(nloc)
+      REAL, DIMENSION (nloc), INTENT (OUT)               :: precip
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ft, fr, fu, fv
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: ftd, fqd
+      REAL, DIMENSION (nloc, nd, ntra), INTENT (OUT)     :: ftra
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: upwd, dnwd, ma
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: dnwd0, mip
+      REAL, DIMENSION (nloc, nd+1), INTENT (OUT)         :: Vprecip
+      REAL, DIMENSION (nloc, nd+1), INTENT (OUT)         :: Vprecipi
+!!      REAL tls(nloc, nd), tps(nloc, nd)                    ! useless . jyg
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qcondc                      ! cld
+      REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: qtc, sigt                   ! cld
+      REAL, DIMENSION (nloc), INTENT (OUT)               :: wd                          ! gust
+      REAL, DIMENSION (nloc), INTENT (OUT)               :: cbmf
 !
 !local variables:
@@ -2887,22 +2942,27 @@
   delti = 1.0/delt
 ! print*,'cv3_yield initialisation delt', delt
-!
+
   DO il = 1, ncum
     precip(il) = 0.0
-    Vprecip(il, nd+1) = 0.0
     wd(il) = 0.0 ! gust
   END DO
 
-  DO i = 1, nd
+!   Fluxes are on a staggered grid : loops extend up to nl+1
+  DO i = 1, nlp
     DO il = 1, ncum
       Vprecip(il, i) = 0.0
+      Vprecipi(il, i) = 0.0                               ! jyg
+      upwd(il, i) = 0.0
+      dnwd(il, i) = 0.0
+      dnwd0(il, i) = 0.0
+      mip(il, i) = 0.0
+    END DO
+  END DO
+  DO i = 1, nl
+    DO il = 1, ncum
       ft(il, i) = 0.0
       fr(il, i) = 0.0
       fu(il, i) = 0.0
       fv(il, i) = 0.0
-      upwd(il, i) = 0.0
-      dnwd(il, i) = 0.0
-      dnwd0(il, i) = 0.0
-      mip(il, i) = 0.0
       ftd(il, i) = 0.0
       fqd(il, i) = 0.0
@@ -2957,6 +3017,8 @@
         IF (cvflag_ice) THEN
           Vprecip(il, i) = wt(il, i)*sigd(il)*(water(il,i)+ice(il,i))/grav
+          Vprecipi(il, i) = wt(il, i)*sigd(il)*ice(il,i)/grav                   ! jyg
         ELSE
           Vprecip(il, i) = wt(il, i)*sigd(il)*water(il, i)/grav
+          Vprecipi(il, i) = 0.                                                  ! jyg
         END IF
       END IF
@@ -3126,6 +3188,12 @@
     IF (num1<=0) GO TO 500
 
-    CALL zilch(amp1, ncum)
-    CALL zilch(ad, ncum)
+!jyg<
+!!    CALL zilch(amp1, ncum)
+!!    CALL zilch(ad, ncum)
+    DO il = 1,ncum
+      amp1(il) = 0.
+      ad(il) = 0.
+    ENDDO
+!>jyg
 
     DO k = 1, nl + 1
@@ -3588,4 +3656,7 @@
     END IF
   END DO
+!
+!    print *,' YIELD : alpha_qpos ',alpha_qpos(1)
+!
   DO il = 1, ncum
     IF (iflag(il)<=1) THEN
@@ -3605,5 +3676,6 @@
         m(il, i) = m(il, i)/alpha_qpos(il)
         mp(il, i) = mp(il, i)/alpha_qpos(il)
-        Vprecip(il, i) = vprecip(il, i)/alpha_qpos(il)
+        Vprecip(il, i) = Vprecip(il, i)/alpha_qpos(il)
+        Vprecipi(il, i) = Vprecipi(il, i)/alpha_qpos(il)                     ! jyg
       END IF
     END DO
@@ -3642,5 +3714,5 @@
 
 
-  DO i = 1, nd
+  DO i = 1, nl
     DO il = 1, ncum
       upwd(il, i) = 0.0
@@ -3654,9 +3726,11 @@
     END DO
   END DO
-  DO i = nl + 1, nd
-    DO il = 1, ncum
-      dnwd0(il, i) = 0.
-    END DO
-  END DO
+!jyg<  (loops stop at nl)
+!!  DO i = nl + 1, nd
+!!    DO il = 1, ncum
+!!      dnwd0(il, i) = 0.
+!!    END DO
+!!  END DO
+!>jyg
 
 
@@ -3753,11 +3827,13 @@
   END DO
 
-  DO i = nl + 1, nd
-    DO il = 1, ncum
-      mip(il, i) = 0.
-    END DO
-  END DO
-
-  DO i = 1, nd
+!jyg<  (loops stop at nl)
+!!  DO i = nl + 1, nd
+!!    DO il = 1, ncum
+!!      mip(il, i) = 0.
+!!    END DO
+!!  END DO
+!>jyg
+
+  DO i = 1, nlp
     DO il = 1, ncum
       ma(il, i) = 0
@@ -3773,9 +3849,11 @@
   END DO
 
-  DO i = nl + 1, nd
-    DO il = 1, ncum
-      ma(il, i) = 0.
-    END DO
-  END DO
+!jyg<  (loops stop at nl)
+!!  DO i = nl + 1, nd
+!!    DO il = 1, ncum
+!!      ma(il, i) = 0.
+!!    END DO
+!!  END DO
+!>jyg
 
   DO i = 1, nl
@@ -3811,5 +3889,5 @@
 !! cld                                                               
                                                                      
-  DO i = 1, nd                                                       ! cld
+  DO i = 1, nl+1                                                     ! cld
     DO il = 1, ncum                                                  ! cld
       mac(il, i) = 0.0                                               ! cld
@@ -3953,6 +4031,6 @@
 ! fraction deau condensee dans les melanges convertie en precip : epm
 ! et eau condensée précipitée dans masse d'air saturé : l_m*dM_m/dzdz.dzdz
-  DO j = 1, na
-    DO k = 1, na
+  DO j = 1, nl
+    DO k = 1, nl
       DO i = 1, ncum
         IF (k>=icb(i) .AND. k<=inb(i) .AND. & 
@@ -3969,6 +4047,6 @@
 
 
-  DO j = 1, na
-    DO k = 1, na
+  DO j = 1, nl
+    DO k = 1, nl
       DO i = 1, ncum
         IF (k>=icb(i) .AND. k<=inb(i)) THEN
@@ -3980,5 +4058,5 @@
   END DO
 
-  DO j = 1, na
+  DO j = 1, nl
     DO k = 1, j - 1
       DO i = 1, ncum
@@ -3991,6 +4069,6 @@
 
 ! matrices pour calculer la tendance des concentrations dans cvltr.F90
-  DO j = 1, na
-    DO k = 1, na
+  DO j = 1, nl
+    DO k = 1, nl
       DO i = 1, ncum
         da(i, j) = da(i, j) + (1.-sigij(i,k,j))*ment(i, k, j)
Index: /LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3a_compress.F90	(revision 2408)
@@ -154,5 +154,5 @@
     PRINT *, 'WARNING nn not equal to ncum: ', nn, ncum
     abort_message = ''
-    CALL abort_gcm(modname, abort_message, 1)
+    CALL abort_physic(modname, abort_message, 1)
   END IF
 
@@ -185,5 +185,5 @@
     PRINT *, 'WARNING nn not equal to ncum: ', nn, ncum
     abort_message = ''
-    CALL abort_gcm(modname, abort_message, 1)
+    CALL abort_physic(modname, abort_message, 1)
   END IF
 !
Index: /LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90	(revision 2408)
@@ -3,5 +3,5 @@
                            precip, cbmf, plcl, plfc, wbeff, sig, w0, ptop2, &
                            ft, fq, fu, fv, ftra,  &
-                           sigd, ma, mip, vprecip, upwd, dnwd, dnwd0, &
+                           sigd, ma, mip, vprecip, vprecipi, upwd, dnwd, dnwd0, &
                            qcondc, wd, cape, cin, &
                            tvp, &
@@ -17,5 +17,5 @@
                            precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, ptop21, &
                            ft1, fq1, fu1, fv1, ftra1, &
-                           sigd1, ma1, mip1, vprecip1, upwd1, dnwd1, dnwd01, &
+                           sigd1, ma1, mip1, vprecip1, vprecipi1, upwd1, dnwd1, dnwd01, &
                            qcondc1, wd1, cape1, cin1, &
                            tvp1, &
@@ -57,4 +57,5 @@
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: ma, mip
   REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: vprecip
+  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: vprecipi
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: upwd, dnwd, dnwd0
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qcondc
@@ -91,4 +92,5 @@
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: ma1, mip1
   REAL, DIMENSION (len, nd+1), INTENT (OUT)          :: vprecip1
+  REAL, DIMENSION (len, nd+1), INTENT (OUT)          :: vprecipi1
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: upwd1, dnwd1, dnwd01
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: qcondc1
@@ -144,5 +146,5 @@
     END DO
    
-    DO k = 1, nl+1
+    DO k = 1, nl
       DO i = 1, ncum
         sig1(idcum(i), k) = sig(i, k)
@@ -155,4 +157,5 @@
         mip1(idcum(i), k) = mip(i, k)
         vprecip1(idcum(i), k) = vprecip(i, k)
+        vprecipi1(idcum(i), k) = vprecipi(i, k)
         upwd1(idcum(i), k) = upwd(i, k)
         dnwd1(idcum(i), k) = dnwd(i, k)
@@ -178,4 +181,14 @@
    
       END DO
+    END DO
+
+! Fluxes are defined on a staggered grid and extend up to nl+1
+    DO i = 1, ncum
+      ma1(idcum(i), nlp) = 0.
+      vprecip1(idcum(i), nlp) = 0.
+      vprecipi1(idcum(i), nlp) = 0.
+      upwd1(idcum(i), nlp) = 0.
+      dnwd1(idcum(i), nlp) = 0.
+      dnwd01(idcum(i), nlp) = 0.
     END DO
    
@@ -203,12 +216,26 @@
 !!      END DO
 !!    END DO
-      DO i = 1, ncum
-        jdcum=idcum(i)
-        phi1    (jdcum, 1:nl+1, 1:nl+1) = phi    (i, 1:nl+1, 1:nl+1)          !AC!
-        phi21   (jdcum, 1:nl+1, 1:nl+1) = phi2   (i, 1:nl+1, 1:nl+1)          !RomP
-        sigij1  (jdcum, 1:nl+1, 1:nl+1) = sigij  (i, 1:nl+1, 1:nl+1)          !RomP
-        elij1   (jdcum, 1:nl+1, 1:nl+1) = elij   (i, 1:nl+1, 1:nl+1)          !RomP
-        epmlmMm1(jdcum, 1:nl+1, 1:nl+1) = epmlmMm(i, 1:nl+1, 1:nl+1)          !RomP+jyg
+
+!!      DO i = 1, ncum
+!!        jdcum=idcum(i)
+!!        phi1    (jdcum, 1:nl+1, 1:nl+1) = phi    (i, 1:nl+1, 1:nl+1)          !AC!
+!!        phi21   (jdcum, 1:nl+1, 1:nl+1) = phi2   (i, 1:nl+1, 1:nl+1)          !RomP
+!!        sigij1  (jdcum, 1:nl+1, 1:nl+1) = sigij  (i, 1:nl+1, 1:nl+1)          !RomP
+!!        elij1   (jdcum, 1:nl+1, 1:nl+1) = elij   (i, 1:nl+1, 1:nl+1)          !RomP
+!!        epmlmMm1(jdcum, 1:nl+1, 1:nl+1) = epmlmMm(i, 1:nl+1, 1:nl+1)          !RomP+jyg
+!!      END DO
+!  These tracer associated arrays are defined up to nl, not nl+1
+  DO i = 1, ncum
+    jdcum=idcum(i)
+    DO k = 1,nl
+      DO j = 1,nl
+        phi1    (jdcum, j, k) = phi    (i, j, k)          !AC!
+        phi21   (jdcum, j, k) = phi2   (i, j, k)          !RomP
+        sigij1  (jdcum, j, k) = sigij  (i, j, k)          !RomP
+        elij1   (jdcum, j, k) = elij   (i, j, k)          !RomP
+        epmlmMm1(jdcum, j, k) = epmlmMm(i, j, k)          !RomP+jyg
       END DO
+    ENDDO
+  ENDDO
 !>jyg
     ! AC!
@@ -246,40 +273,49 @@
       asupmaxmin1(:) = asupmaxmin(:)
 !
-      sig1(:, 1:nl+1) = sig(:, 1:nl+1)
-      w01(:, 1:nl+1) = w0(:, 1:nl+1)
-      ft1(:, 1:nl+1) = ft(:, 1:nl+1)
-      fq1(:, 1:nl+1) = fq(:, 1:nl+1)
-      fu1(:, 1:nl+1) = fu(:, 1:nl+1)
-      fv1(:, 1:nl+1) = fv(:, 1:nl+1)
-      ma1(:, 1:nl+1) = ma(:, 1:nl+1)
-      mip1(:, 1:nl+1) = mip(:, 1:nl+1)
-      vprecip1(:, 1:nl+1) = vprecip(:, 1:nl+1)
-      upwd1(:, 1:nl+1) = upwd(:, 1:nl+1)
-      dnwd1(:, 1:nl+1) = dnwd(:, 1:nl+1)
-      dnwd01(:, 1:nl+1) = dnwd0(:, 1:nl+1)
-      qcondc1(:, 1:nl+1) = qcondc(:, 1:nl+1)
-      tvp1(:, 1:nl+1) = tvp(:, 1:nl+1)
-      ftd1(:, 1:nl+1) = ftd(:, 1:nl+1)
-      fqd1(:, 1:nl+1) = fqd(:, 1:nl+1)
-      asupmax1(:, 1:nl+1) = asupmax(:, 1:nl+1)
-
-      da1(:, 1:nl+1) = da(:, 1:nl+1)              !AC!
-      mp1(:, 1:nl+1) = mp(:, 1:nl+1)              !RomP
-      d1a1(:, 1:nl+1) = d1a(:, 1:nl+1)            !RomP
-      dam1(:, 1:nl+1) = dam(:, 1:nl+1)            !RomP
-      clw1(:, 1:nl+1) = clw(:, 1:nl+1)            !RomP
-      evap1(:, 1:nl+1) = evap(:, 1:nl+1)          !RomP
-      ep1(:, 1:nl+1) = ep(:, 1:nl+1)              !RomP
-      eplamM1(:, 1:nl+1) = eplamM(:, 1:nl+1)       !RomP+jyg
-      wdtrainA1(:, 1:nl+1) = wdtrainA(:, 1:nl+1)  !RomP
-      wdtrainM1(:, 1:nl+1) = wdtrainM(:, 1:nl+1)  !RomP
-      qtc1(:, 1:nl+1) = qtc(:, 1:nl+1)
-      sigt1(:, 1:nl+1) = sigt(:, 1:nl+1)
-!
-      phi1    (:, 1:nl+1, 1:nl+1) = phi    (:, 1:nl+1, 1:nl+1)  !AC!
-      phi21   (:, 1:nl+1, 1:nl+1) = phi2   (:, 1:nl+1, 1:nl+1)  !RomP
-      sigij1  (:, 1:nl+1, 1:nl+1) = sigij  (:, 1:nl+1, 1:nl+1)  !RomP
-      elij1   (:, 1:nl+1, 1:nl+1) = elij   (:, 1:nl+1, 1:nl+1)  !RomP
-      epmlmMm1(:, 1:nl+1, 1:nl+1) = epmlmMm(:, 1:nl+1, 1:nl+1)  !RomP+jyg
+      sig1(:, 1:nl) = sig(:, 1:nl)
+      w01(:, 1:nl) = w0(:, 1:nl)
+      ft1(:, 1:nl) = ft(:, 1:nl)
+      fq1(:, 1:nl) = fq(:, 1:nl)
+      fu1(:, 1:nl) = fu(:, 1:nl)
+      fv1(:, 1:nl) = fv(:, 1:nl)
+      ma1(:, 1:nl) = ma(:, 1:nl)
+      mip1(:, 1:nl) = mip(:, 1:nl)
+      vprecip1(:, 1:nl) = vprecip(:, 1:nl)
+      vprecipi1(:, 1:nl) = vprecipi(:, 1:nl)
+      upwd1(:, 1:nl) = upwd(:, 1:nl)
+      dnwd1(:, 1:nl) = dnwd(:, 1:nl)
+      dnwd01(:, 1:nl) = dnwd0(:, 1:nl)
+      qcondc1(:, 1:nl) = qcondc(:, 1:nl)
+      tvp1(:, 1:nl) = tvp(:, 1:nl)
+      ftd1(:, 1:nl) = ftd(:, 1:nl)
+      fqd1(:, 1:nl) = fqd(:, 1:nl)
+      asupmax1(:, 1:nl) = asupmax(:, 1:nl)
+
+      da1(:, 1:nl) = da(:, 1:nl)              !AC!
+      mp1(:, 1:nl) = mp(:, 1:nl)              !RomP
+      d1a1(:, 1:nl) = d1a(:, 1:nl)            !RomP
+      dam1(:, 1:nl) = dam(:, 1:nl)            !RomP
+      clw1(:, 1:nl) = clw(:, 1:nl)            !RomP
+      evap1(:, 1:nl) = evap(:, 1:nl)          !RomP
+      ep1(:, 1:nl) = ep(:, 1:nl)              !RomP
+      eplamM1(:, 1:nl) = eplamM(:, 1:nl)       !RomP+jyg
+      wdtrainA1(:, 1:nl) = wdtrainA(:, 1:nl)  !RomP
+      wdtrainM1(:, 1:nl) = wdtrainM(:, 1:nl)  !RomP
+      qtc1(:, 1:nl) = qtc(:, 1:nl)
+      sigt1(:, 1:nl) = sigt(:, 1:nl)
+!
+      ma1(:, nlp) = 0.
+      vprecip1(:, nlp) = 0.
+      vprecipi1(:, nlp) = 0.
+      upwd1(:, nlp) = 0.
+      dnwd1(:, nlp) = 0.
+      dnwd01(:, nlp) = 0.
+
+!
+      phi1    (:, 1:nl, 1:nl) = phi    (:, 1:nl, 1:nl)  !AC!
+      phi21   (:, 1:nl, 1:nl) = phi2   (:, 1:nl, 1:nl)  !RomP
+      sigij1  (:, 1:nl, 1:nl) = sigij  (:, 1:nl, 1:nl)  !RomP
+      elij1   (:, 1:nl, 1:nl) = elij   (:, 1:nl, 1:nl)  !RomP
+      epmlmMm1(:, 1:nl, 1:nl) = epmlmMm(:, 1:nl, 1:nl)  !RomP+jyg
   ENDIF !(compress)
 !>jyg
Index: /LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2408)
@@ -19,4 +19,5 @@
   ! **************************************************************
 
+  USE print_control_mod, ONLY: prt_level, lunout
   IMPLICIT NONE
 
@@ -26,5 +27,4 @@
   include "YOMCST.h"
   include "conema3.h"
-  include "iniprint.h"
 
   ! input:
@@ -552,5 +552,5 @@
         , il, alp2(il), alp(il), cin(il)
       abort_message = ''
-      CALL abort_gcm(modname, abort_message, 1)
+      CALL abort_physic(modname, abort_message, 1)
     END IF
     cbmfmax(il) = sigmax*wb2(il)*100.*p(il, icb(il))/(rrd*tv(il,icb(il)))
